const char lava_code[] = "\n\
\n\
proc init_canvas {} {\n\
canvas .c -width 100 -height 200 -bg black\n\
pack append . .c expand\n\
\n\
bind . <Configure> \"canvas_configure %W %w %h\"\n\
.c bind p <Any-ButtonPress-1> \"info_click_down %x %y %X %Y\"\n\
bind .c <Any-ButtonRelease-1> \"info_click_up\"\n\
bind .c <Any-B1-Motion> \"info_click_down %x %y %X %Y\"\n\
bind .c <Any-ButtonPress-3> \"tk_popup .menu %X %Y 0\"\n\
bind .c <Any-ButtonPress-2> \"tk_popup .menu %X %Y 0\"\n\
}\n\
\n\
proc canvas_configure {W w h} {\n\
if {\"$W\" != \".\"} {\n\
return\n\
}\n\
incr w -2\n\
incr h -2\n\
global old_canvas_w old_canvas_h\n\
if {[info exists old_canvas_w]} {\n\
if {$old_canvas_w == $w && $old_canvas_h == $h} {\n\
return\n\
}\n\
}\n\
lava_resize $w $h\n\
.c configure -height $h -width $w\n\
}\n\
\n\
proc init_help {} {\n\
global help\n\
set help(about) \"<big>Lava PS [lava_version]</big>\n\
\n\
Copyright (C) 1999 by John Heidemann\n\
All rights reserved.\n\
Comments to <computer><johnh@isi.edu></computer>, latest version at <computer><http://www.isi.edu/~johnh/SOFTWARE/LAVAPS/></computer>\n\
\n\
Lava PS is an interactive process-tracking program like ``top'', but with a much different attitude.  Rather than presenting lots of specific info in digital form, it tries to present certain important information in a graphical analog form.  The idea is that you can run it in the background and get a rough idea of what's happening to your system without devoting much concentration to the task.\n\
\n\
Lava PS was inspired by Mark Weiser's idea of calm computing.  For details, see:\n\
\n\
Mark Weiser and John Seely Brown.  The Coming Age of Calm Technology, Revised version of Weiser & Brown. ``Designing Calm Technology'', PowerGrid Journal, v 1.01, http://powergrid.electriciti.com/1.01 (July 1996). October, 1996. <http://www.ubiq.com/hypertext/weiser/acmfuture2endnote.htm>.\n\
\n\
(This program dedicated to the memory of M.W.--I hope you would have thought it a good hack.)\n\
\"\n\
}\n\
\n\
proc init_menu {} {\n\
global menu rdb\n\
set m [menu .menu -tearoff 0]\n\
\n\
set mw .menu.who\n\
menu $mw -tearoff 0\n\
$mw add radiobutton -label \"Me\" -variable menu(who) -value me -command \"menu_set who me {my jobs\\n}\"\n\
$mw add radiobutton -label \"Everyone\" -variable menu(who) -value everyone -command \"menu_set who everyone {all jobs\\n}\"\n\
set_rdb_default who me\n\
set menu(who) $rdb(who)\n\
menu_set who $menu(who)\n\
$m add cascade -label \"Who\" -menu $mw\n\
\n\
set mw .menu.what\n\
menu $mw -tearoff 0\n\
$mw add radiobutton -label \"Virtual Memory\" -variable menu(what) -value virtual -command \"menu_set what virtual {virtual mem\\n}\"\n\
$mw add radiobutton -label \"Physical Memory\" -variable menu(what) -value physical -command \"menu_set what physical {physical mem\\n}\"\n\
$mw add radiobutton -label \"Both\" -variable menu(what) -value both -command \"menu_set what both {both mem\\n}\"\n\
set_rdb_default what virtual {virtual physical both}\n\
set menu(what) $rdb(what)\n\
menu_set what $rdb(what)\n\
$m add cascade -label \"What\" -menu $mw\n\
\n\
set mw .menu.how\n\
menu $mw -tearoff 0\n\
$mw add command -label \"Shrink\" -command {menu_set how shrink \"shrink mem\\n\"}\n\
$mw add command -label \"Grow\" -command {menu_set how grow \"grow mem\\n\"}\n\
$mw add checkbutton -label \"Autoresizing\" -variable menu(how) -onvalue 1 -offvalue 0 -command {menu_autoresize force}\n\
set_rdb_default_boolean autoresize 1\n\
set menu(how) $rdb(autoresize)\n\
menu_set how $menu(how)\n\
$m add cascade -label \"How\" -menu $mw\n\
\n\
$m add command -label \"About...\" -command \"menuHelp about\"\n\
$m add separator\n\
\n\
$m add command -label \"Quit\" -command \"exit 0\"\n\
}\n\
\n\
proc menu_autoresize {status} {\n\
global menu\n\
switch -exact $status {\n\
off {\n\
if {$menu(how) != 0} {\n\
set menu(how) 0\n\
menu_set how 0 \"manual resize\\n\"\n\
}\n\
}\n\
force {\n\
if {$menu(how)} {\n\
menu_set how 1 \"auto-resize\\n\"\n\
} else {\n\
menu_set how 0 \"manual resize\\n\"\n\
}\n\
}\n\
default {\n\
die \"bad menu_autoresize argument\"\n\
}\n\
}\n\
}\n\
\n\
proc menu_set {what token {feedback \"\"}} {\n\
global menu\n\
lava_menu $what $token\n\
if {$feedback != \"\"} {\n\
splash_refresh $feedback\n\
}\n\
}\n\
\n\
proc init_debugging {} {\n\
global rdb\n\
set_rdb_default_boolean debug 0\n\
lava_menu debug $rdb(debug)\n\
}\n\
\n\
proc debugging {} {\n\
global rdb\n\
return $rdb(debug)\n\
}\n\
\n\
proc init_info {} {\n\
toplevel .info \n\
wm transient .info .\n\
wm group .\n\
wm withdraw .info\n\
wm iconname .info \"\"\n\
global info_default_wh\n\
set info_default_wh {24 6}\n\
if {[debugging]} {\n\
set info_default_wh {30 7}\n\
}\n\
label .info.color -height 1 -width [lindex $info_default_wh 0] -text \" \"\n\
text .info.text -width [lindex $info_default_wh 0] -height [lindex $info_default_wh 1]\n\
pack .info.color\n\
pack .info.text\n\
global info_last_x info_last_y info_last_id\n\
set info_last_x -1\n\
set info_last_y -1\n\
set info_last_id -1\n\
}\n\
\n\
proc info_click_down {x y rx ry} {\n\
global info_last_x info_last_y info_last_id\n\
\n\
set try_again 1\n\
while {$try_again} {\n\
set id [.c find closest $x $y]\n\
\n\
if {$info_last_id == $id && $info_last_x == $x && $info_last_y == $y} {\n\
return\n\
}\n\
if {$info_last_id == $id} {\n\
wm geometry .info \"+$rx+$ry\"\n\
return\n\
}\n\
global splash_id\n\
if {$id == $splash_id} {\n\
splash_destroy\n\
set try_again 1\n\
} else {\n\
set try_again 0\n\
}\n\
}\n\
set info_last_x $x\n\
set info_last_y $y\n\
set info_last_id $id\n\
\n\
.info.color config -background [lindex [.c itemconfigure $id -fill] 4]\n\
\n\
global env\n\
set text [lava_id_to_info $id]\n\
global info_default_wh\n\
.info.text delete 0.0 end\n\
.info.text insert 0.0 $text\n\
.info.text config -width [lindex $info_default_wh 0] -height [lindex $info_default_wh 1]\n\
wm geometry .info \"+$rx+$ry\"\n\
wm deiconify .info\n\
}\n\
proc info_click_up {} {\n\
global info_last_id\n\
set info_last_id -1\n\
wm withdraw .info\n\
}\n\
\n\
proc splash_create {text} {\n\
global splash_id splash_gray splash_last\n\
set splash_id [.c create text 50 50 -anchor center -fill white -text $text -font {-family Helvetica -weight bold}]\n\
set splash_gray 255\n\
set splash_last $text\n\
after 4000 splash_fade\n\
}\n\
proc splash_destroy {} {\n\
global splash_id\n\
.c delete $splash_id\n\
set splash_id dead\n\
}\n\
proc splash_refresh {text} {\n\
global splash_id splash_gray splash_last splash_last_count\n\
if {$splash_id == \"dead\"} {\n\
splash_create $text\n\
} else {\n\
set splash_gray 255\n\
if {\"$text\" == \"$splash_last\"} {\n\
if {$splash_last_count > 1} {\n\
set len [string length $splash_last_count]\n\
set e [expr [.c index $splash_id end] - 2 - $len]\n\
.c dchars $splash_id $e [expr $e + 1 + $len]\n\
} else {\n\
set e [expr [.c index $splash_id end] - 1]\n\
}\n\
incr splash_last_count\n\
.c insert $splash_id $e \" $splash_last_count\\n\"\n\
} else {\n\
.c insert $splash_id end $text\n\
set splash_last $text\n\
set splash_last_count 1\n\
}\n\
}\n\
}\n\
proc splash_fade {} {\n\
global splash_id splash_gray\n\
incr splash_gray -6\n\
if {$splash_gray <= 0} {\n\
splash_destroy\n\
} else {\n\
set g [format \"%02x\" $splash_gray]\n\
.c itemconf $splash_id -fill \"#$g$g$g\"\n\
.c itemconf raise $splash_id\n\
after 1000 splash_fade\n\
}\n\
}\n\
proc init_splash {} {\n\
global splash_id\n\
set splash_id dead\n\
}\n\
\n\
proc make_scale {tag} {\n\
}\n\
proc make_scales {} {\n\
make_scale mem\n\
}\n\
\n\
if {0} {\n\
fconfigure stdin -blocking false -buffering line\n\
fileevent stdin readable lava_debug_callback\n\
proc lava_debug_callback {} {\n\
gets stdin line\n\
puts \"lava_debug_callback: $line\"\n\
eval $line\n\
}\n\
}\n\
\n\
proc lava_ticker {cookie} {\n\
global lava_tick_cookie\n\
if {$cookie < $lava_tick_cookie} {\n\
return\n\
}\n\
\n\
lava_tick\n\
\n\
global splash_id\n\
if {$splash_id != \"dead\"} {\n\
.c raise $splash_id\n\
}\n\
\n\
global lava_tick_interval\n\
incr lava_tick_cookie\n\
after $lava_tick_interval \"lava_ticker $lava_tick_cookie\"\n\
}\n\
proc lava_ticker_always {} {\n\
global lava_tick_cookie\n\
lava_ticker $lava_tick_cookie\n\
}\n\
proc init_ticker {} {\n\
global lava_tick_interval lava_tick_cookie\n\
set lava_tick_interval 2000\n\
set lava_tick_cookie 0\n\
after 10 lava_ticker_always\n\
}\n\
\n\
\n\
proc main {} {\n\
wm iconname . \"lavaps\"\n\
wm title . \"lavaps\"\n\
tk appname lavaps\n\
\n\
init_splash\n\
init_resources\n\
init_debugging\n\
init_canvas\n\
init_help\n\
init_menu\n\
init_info\n\
\n\
splash_refresh \"buttons:\\nleft: info\\nright: menu\\n\"\n\
\n\
init_ticker\n\
}\n\
\n\
\n\
set rcsid(help.tcl) {$Id: help.tcl,v 1.5 1999/09/10 05:57:13 johnh Exp $}\n\
\n\
proc readRelease {} {\n\
global game\n\
set catchval [catch {\n\
set f [open $game(releasefile) r]\n\
gets $f release\n\
close $f\n\
return $release\n\
} ret]\n\
if { $catchval == 2 } {\n\
return $ret\n\
} else {\n\
return \"unknown-release\"\n\
}\n\
}\n\
\n\
\n\
proc menuHighScores {} {\n\
displayHighScores\n\
}\n\
\n\
proc menuFinishGame {} {\n\
endGame \"quit\"\n\
}\n\
\n\
proc menuQuit {} {\n\
global table\n\
endGame \"quit\"\n\
exit 0\n\
}\n\
\n\
\n\
\n\
\n\
proc wmConfig {w title} {\n\
global stackList\n\
\n\
if { [info exists stackList] == 0 } {\n\
set stackList \".\"\n\
}\n\
set geometry [wm geometry [lindex $stackList [expr [llength $stackList] - 1]]]\n\
set geoElems [split $geometry \"x+\"]\n\
set geoX [lindex $geoElems 2]\n\
set geoY [lindex $geoElems 3]\n\
set neoGeoX [expr $geoX + 50]\n\
set neoGeoY [expr $geoY + 50]\n\
wm geometry $w [format \"+%d+%d\" $neoGeoX $neoGeoY]\n\
lappend stackList $w\n\
wm protocol $w WM_DELETE_WINDOW \"unmenuHelp $w\"\n\
wm group $w .\n\
wm title $w $title\n\
wm iconname $w $title\n\
}\n\
proc unmenuHelp {w} {\n\
global stackList tk_version\n\
if { [set listPos [lsearch -exact $stackList $w]] != -1 } {\n\
set stackList [lreplace $stackList $listPos $listPos]\n\
}\n\
destroy $w\n\
}\n\
\n\
proc setMenuHelpKeyboardBindings {top target} {\n\
global tk_version\n\
if {$tk_version < 4.0} {\n\
bind $top <Any-Enter> \"focus $target\"\n\
} else {\n\
focus $target\n\
$target configure -takefocus 1\n\
}\n\
bind $target <Any-KeyPress-Return> \"unmenuHelp $top\"\n\
bind $target <Any-KeyPress-Escape> \"unmenuHelp $top\"\n\
bind $target <Any-KeyPress-KP_Enter> \"unmenuHelp $top\"\n\
}\n\
\n\
\n\
proc menuHelp {topic {titleWord \"\"}} {\n\
global help helpWindowList \n\
\n\
set w \".${topic}\"\n\
catch {unmenuHelp $w}\n\
set tl [toplevel $w]\n\
if { $titleWord == \"\" } { set titleWord	$topic }\n\
wmConfig $w \"Lava-ps--$titleWord\"\n\
set padValue 8\n\
button $w.ok -text OK -padx [expr 2*$padValue] -command \"unmenuHelp $w\"\n\
text $w.t \\\n\
-relief raised -bd 2 -yscrollcommand \"$w.s set\" \\\n\
-setgrid true -wrap word \\\n\
-width 60 -padx $padValue -pady $padValue \\\n\
-font -*-Times-Medium-R-*-140-*\n\
set defFg [lindex [$w.t configure -foreground] 4]\n\
set defBg [lindex [$w.t configure -background] 4]\n\
$w.t tag configure italic -font -*-Times-Medium-I-Normal-*-140-*\n\
$w.t tag configure computer -font -*-Courier-Medium-R-Normal-*-120-*\n\
$w.t tag configure big -font -*-Times-Bold-R-Normal-*-180-*\n\
$w.t tag configure reverse -foreground $defBg -background $defFg\n\
\n\
scrollbar $w.s -relief flat -command \"$w.t yview\"\n\
pack append $w $w.ok {bottom} $w.s {right filly} $w.t {expand fill}\n\
\n\
$w.t mark set insert 0.0\n\
\n\
setMenuHelpKeyboardBindings $w \"$w.ok\"\n\
\n\
set t $help($topic)\n\
while { [regexp -indices {<([^@>]*)>} $t match inds] == 1 } {\n\
set start [lindex $inds 0]\n\
set end [lindex $inds 1]\n\
\n\
set keyword [string range $t $start $end]\n\
\n\
set oldend [$w.t index end]\n\
$w.t insert end [string range $t 0 [expr $start-2]]\n\
purgeAllTags $w.t $oldend insert\n\
\n\
if { [string range $keyword 0 0] == \"/\" } {\n\
set keyword [string trimleft $keyword \"/\"]\n\
if { [info exists tags($keyword)] == 0 } {\n\
error \"end tag $keyword without beginning\"\n\
}\n\
$w.t tag add $keyword $tags($keyword) insert\n\
unset tags($keyword)\n\
} else {\n\
if { [info exists tags($keyword)] == 1 } {\n\
error \"nesting of begin tag $keyword\"\n\
}\n\
set tags($keyword) [$w.t index insert]\n\
}\n\
\n\
set t [string range $t [expr $end+2] end]\n\
}\n\
set oldend [$w.t index end]\n\
$w.t insert end $t\n\
purgeAllTags $w.t $oldend insert\n\
$w.t configure -state disabled\n\
}\n\
\n\
proc purgeAllTags {w start end} {\n\
foreach tag [$w tag names $start] {\n\
$w tag remove $tag $start $end\n\
}\n\
}\n\
\n\
proc menuHelpScrollToTag {topic tag} {\n\
set w \".${topic}\"\n\
\n\
catch {$w.t yview -pickplace reverse.first}\n\
}\n\
\n\
\n\
proc debugLog {s} {\n\
puts $s\n\
}\n\
proc debugLogPause {s} {\n\
update idletasks\n\
puts $s\n\
puts \"\\[pause\\]\"\n\
gets stdin dummy\n\
}\n\
\n\
proc set_rdb_default {elem default {acceptable \"\"}} {\n\
global rdb\n\
if {![info exists rdb($elem)]} {\n\
set rdb($elem) $default\n\
return 1\n\
} else {\n\
if {$acceptable != \"\"} {\n\
if {[lsearch -exact $acceptable $rdb($elem)] == -1} {\n\
puts stderr \"bad resource value: $elem $rdb($elem)\"\n\
set rdb($elem) $default\n\
return 1\n\
}\n\
}\n\
}\n\
return 0\n\
}\n\
\n\
proc rdb_boolean {v} {\n\
set v [string tolower $v]\n\
set v [string trim $v { 	}]\n\
set v [string trimleft $v { 	}]\n\
switch -regexp $v {\n\
{(false|off|0|no)} { set vv 0 }\n\
default { set vv 1 }\n\
}\n\
}\n\
\n\
proc set_rdb_default_boolean {elem default} {\n\
global rdb\n\
set_rdb_default $elem $default\n\
set rdb($elem) [rdb_boolean $rdb($elem)]\n\
}\n\
\n\
\n\
proc init_resources {} {\n\
global rdb env\n\
\n\
set rdb(moduledir) \"$env(HOME)/.tk/lavaps\"\n\
set rdb(homemoduledir) \"$env(HOME)/.tk/lavaps\"\n\
set rdb(startupfile) \"$rdb(homemoduledir)/startup.tcl\"\n\
\n\
set f [open \"|xrdb -query\" r]\n\
while {[gets $f l] >= 0} {\n\
if {[regexp {^[Ll]ava[Pp][Ss][.*]([_A-Za-z0-9.]+):[ 	]+(.*)$} $l t key value]} {\n\
set key [string tolower $key]\n\
set rdb($key) $value\n\
}\n\
}\n\
close $f\n\
if {[file exists $rdb(startupfile)]} { \n\
}\n\
if {[info exists rdb(geometry)]} {\n\
wm geometry . $rdb(geometry)\n\
}\n\
}\n\
\n\
";
